package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_powsp extends Object {

	public static void main(String args[]) {

    int n,l,i,i1,i2;
    double fact,argu;
    double x[] = new double[121];
    double y[] = new double[121];
    double psx[] = new double[6];
    double psy[] = new double[6];
    double xps[] = new double[11];

    x[1]=1.4696;  x[2]=-0.08554;  x[3]=0.50465;  x[4]=0.24784;
    x[5]=0.95925; x[6]=-1.4027;   x[7]=1.3512;   x[8]=0.75327;
    x[9]=1.4586;  x[10]=0.2469;   x[11]=-2.2006; x[12]=-1.0595;
    x[13]=-0.73718; x[14]=-1.5057; x[15]=0.0;    x[16]=0.0;
    if (!FFT.powsp(x,y,16,4,false,psx,psy,xps))  return;
    DecimalFormat sevenDigit = new DecimalFormat("0.0000000E0");
    System.out.println("first part of the example produces:\n\n" +
      "  psx :  " + sevenDigit.format(psx[1]) + "\n         " +
      sevenDigit.format(psx[2]) + "\n         " +
      sevenDigit.format(psx[3]) + "\n\n" +
      "second part of the example produces:\n");
    n=120;
    l=8;
    fact=6.283185307179586;
    for (i=1; i<=n; i++) {
      argu=(i-1)*fact;
      x[i]=Math.sin(argu);
      y[i]=Math.cos(argu);
    }
    if (!FFT.powsp(x,y,n,l,true,psx,psy,xps))  return;
    i1=l/2+1;
    for (i=1; i<=i1; i++)
      System.out.println("  psx(" + i + ") = " +
        sevenDigit.format(psx[i]) + "    " + "psy(" + i + 
        ") = " + sevenDigit.format(psy[i]));
    i2=l+2;
    System.out.println("\nvalues of xps:\n");
    for (i=1; i<=i2; i++) {
      System.out.println("  " + sevenDigit.format(xps[i]));
      if (i == i1)
        System.out.println();
    }
  }
}
