package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_rfftr extends Object {

	public static void main(String args[]) {

    int i,k,n,n2,i1,i2;
    double xi,x,fact1,fact2,term,tx,tpn,den,sint,r1,r2,cost;
    double a[] = new double[101];
    double gamn[] = new double[3];

    x=0.9;
    n=26;
    n2=n/2;
    xi=1.0;
    for (i=1; i<=n; i++) {
      a[i]=xi;
      xi=x*xi;
    }
    FFT.rfftr(a,gamn,n);
    DecimalFormat sevenDigit = new DecimalFormat("0.0000000E0");
    System.out.println("results produced by fast fourier " +
      "transform program:\n");
    for (i=1; i<=n2; i++) {
      i2=2*i;
      i1=i2-1;
      System.out.println("  " + sevenDigit.format(a[i1]) +
        "    " + sevenDigit.format(a[i2]));
    }
    System.out.println("\n  gamn = " + sevenDigit.format(gamn[1]) +
      "    " + sevenDigit.format(gamn[2]));
    fact1=1.0-Math.pow(x,n);
    fact2=x*fact1;
    term=1.0+x*x;
    tpn=Math.PI/n2;
    tx=2.0*x;
    n2=n2+1;
    System.out.println("\ncorrect answers :\n");
    for (i=1; i<=n2; i++) {
      k=i-1;
      cost=Math.cos(tpn*k);
      sint=Math.sin(tpn*k);
      den=term-tx*cost;
      r1=(fact1-fact2*cost)/den;
      r2=fact2*sint/den;
      if (i == n2)
        System.out.println();
      System.out.println("  " + sevenDigit.format(r1) +
        "    " + sevenDigit.format(r2));
    }
  }
}
