package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_chldecsol1 extends Object {
	
	public static void main(String args[]) {

    int i,j,jj;
    double determinant;
    double b[] = new double[5];
    double aux[] = new double[4];
    double pascal1[] = new double[(((4+1)*4)/2)+1];

    jj=1;
    for (j=1; j<=4; j++) {
      pascal1[jj]=1.0;
      for (i=2; i<=j; i++)
        pascal1[jj+i-1] = (i == j) ?
            pascal1[jj+i-2]*2.0 : pascal1[jj+i-2]+pascal1[jj+i-j];
      b[j]=Math.pow(2.0,j);
      jj += j;
    }
    aux[2]=1.0e-11;
    Linear_algebra.chldecsol1(pascal1,4,aux,b);
    determinant=0.0;
    if (aux[3] == 4)
      determinant=Linear_algebra.chldeterm1(pascal1,4);
    else
      System.out.println("Matrix not positive definite");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("Solution with CHLDECSOL1:\n  " + 
      fiveDigit.format(b[1]) + "  " + fiveDigit.format(b[2]) + "  " +
      fiveDigit.format(b[3]) + "  " + fiveDigit.format(b[4]));
    System.out.println("\nDeterminant with CHLDETERM1: " + determinant);
    jj=1;
    for (j=1; j<=4; j++) {
      pascal1[jj]=1.0;
      for (i=2; i<=j; i++)
        pascal1[jj+i-1] = (i == j) ?
            pascal1[jj+i-2]*2.0 : pascal1[jj+i-2]+pascal1[jj+i-j];
      jj += j;
    }
    Linear_algebra.chldecinv1(pascal1,4,aux);
    System.out.println("\nInverse matrix with CHLDECINV1:");
    for (i=1; i<=4; i++) {
      for (j=1; j<=4; j++)
        if (j < i)
          System.out.print("\t");
        else
          System.out.print("\t" + pascal1[((j-1)*j)/2+i]);
      System.out.print("\n");
    }
	}
}
