package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_conjgrad extends Object implements LA_conjgrad_methods {
	
	public static void main(String args[]) {

    int i;
    int it[] = new int[1];
    double no[] = new double[1];
    double x[] = new double[13];
    double b[] = new double[13];

    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    for (i=0; i<=12; i++) x[i]=b[i]=0.0;
    b[0]=1.0;  b[12]=4.0;
    Test_conjgrad testconjgrad = new Test_conjgrad();;
    Linear_algebra.conjgrad(testconjgrad,x,b,0,12,it,no);
    System.out.println("Delivers:\n  IT = " + it[0] + ",    NO = " + 
               fiveDigit.format(no[0]) + "\n\n      X          R\n");
    for (i=0; i<=12; i++)
      System.out.println("  " + fiveDigit.format(x[i]) + "   " + 
                         fiveDigit.format(b[i]));
	}
	
  public void matvec(double x[], double b[]) {
    
    int i;

    b[0]=2.0*x[0]-x[1];
    for (i=1; i<=11; i++) b[i] = -x[i-1]+2.0*x[i]-x[i+1];
    b[12]=2.0*x[12]-x[11];
  }
  
  public boolean goon(int iter[], double norm[]) {    
    return (iter[0]<20 && norm[0]>1.0e-10);
  }
}
