package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_eighrm extends Object {
	
	public static void main(String args[]) {

    int i;
    double val[] = new double[2]; 
    double em[] = new double[10];
    double a[][] = new double[5][5];
    double vecr[][] = new double[5][2];
    double veci[][] = new double[5][2];
    
    Basic.inimat(1,4,1,4,a,0.0);
    a[1][1]=a[2][2]=3.0;
    a[1][2]=a[3][3]=a[3][4]=a[4][4]=1.0;
    a[3][2]=2.0;  a[4][1] = -2.0;
    em[0]=5.0e-6;
    em[2]=1.0e-5;
    em[4]=0.01;
    em[6]=1.0e-5;
    em[8]=5.0;
    Linear_algebra.eighrm(a,4,1,val,vecr,veci,em);
    Basic.sclcom(vecr,veci,4,1,1);
    DecimalFormat threeDigit = new DecimalFormat("0.000");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("Largest eigenvalue:  " +
      fiveDigit.format(val[1]) + "\n\nCorresponding eigenvector:");
    for (i=1; i<=4; i++)
      System.out.println("  " + threeDigit.format(vecr[i][1]) +
        "  " + threeDigit.format(veci[i][1]) + "*I");
    System.out.println("\nEM[1]:  " + fiveDigit.format(em[1]) +
      "\nEM[3]:  " + fiveDigit.format(em[3]) +
      "\nEM[5]:  " + fiveDigit.format(em[5]) +
      "\nEM[7]:  " + fiveDigit.format(em[7]) +
      "\nEM[9]:  " + fiveDigit.format(em[9]));
	}
}
