package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_gsssolerb extends Object {
	
	public static void main(String args[]) {

    int i,j;
    double b[] = new double[5];
    double aux[] = new double[12];
    double a[][] = new double[5][5];
    
    for (i=1; i<=4; i++) {
      for (j=1; j<=4; j++) a[i][j]=1.0/(i+j-1);
      b[i]=a[i][3];
    }
    aux[0]=aux[2]=aux[6]=1.0e-14;
    aux[4]=8;
    Linear_algebra.gsssolerb(a,4,aux,b);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("Solution:  " + fiveDigit.format(b[1]) +
      "  " + fiveDigit.format(b[2]) + "  " +
      fiveDigit.format(b[3]) + "  " + fiveDigit.format(b[4]));
    System.out.println("Sign(Det) = " + (int)aux[1] + 
      "\nNumber of eliminations = " + (int)aux[3] + 
      "\nMax(abs(a[i,j])) = " + fiveDigit.format(aux[5]) + 
      "\nUpper bound growth = " + fiveDigit.format(aux[7]) +
      "\n1-norm of the inverse matrix = " + fiveDigit.format(aux[9]) +
      "\nUpper bound rel. error in the calc. solution = " +
      fiveDigit.format(aux[11]));
	}
}
