package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_lupzerortpol extends Object {
	
	public static void main(String args[]) {

    int i;
    double b[] = new double[4];
    double c[] = new double[4];
    double zer[] = new double[3];
    double em[] = new double[7];
    
    em[0]=em[2]=1.0e-6;  em[4]=45.0;  em[6]=1.0;
    for (i=0; i<=2; i++) {
      b[i]=2*i+1;
      c[i]=i*i;
    }
    Linear_algebra.lupzerortpol(3,2,b,c,zer,em);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("The two lower zeros:\n  " +
      fiveDigit.format(zer[1]) + "\n  " +
      fiveDigit.format(zer[2]) + "\n\n" + "EM[1]:  " + em[1] +
      "\nEM[3]:  " + fiveDigit.format(em[3]) +
      "\nEM[5]:  " + (int)em[5]);
    em[6]=0.0;
    for (i=0; i<=2; i++) {
      b[i] = -2*i-1;
      c[i]=i*i;
    }
    Linear_algebra.lupzerortpol(3,2,b,c,zer,em);
    System.out.println("\nThe two upper zeros:\n  " +
      fiveDigit.format(-zer[1]) + "\n  " +
      fiveDigit.format(-zer[2]) + "\n\n" + "EM[1]:  " + em[1] +
      "\nEM[3]:  " + fiveDigit.format(em[3]) +
      "\nEM[5]:  " + (int)em[5]);
	}
}
