package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_qricom extends Object {
	
	public static void main(String args[]) {

    int i;
    double b[] = new double[4];
    double val1[] = new double[5];
    double val2[] = new double[5]; 
    double em[] = new double[6];
    double a1[][] = new double[5][5];
    double a2[][] = new double[5][5];
    double vec1[][] = new double[5][5];
    double vec2[][] = new double[5][5];

    Basic.inimat(1,4,1,4,a1,0.0);
    Basic.inimat(1,4,1,4,a2,0.0);
    a1[1][1] = -4.0;  a1[1][2] = -5.0;
    a1[1][3] = a2[1][1] = a2[1][4] = -2.0;
    a2[1][2] = a2[1][3] = -6.0;
    b[1]=b[2]=b[3]=1.0;
    em[0]=5.0e-6;  em[1]=27.0;  em[2]=1.0e-6;  em[4]=15.0;
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("QRICOM:  " + 
      Linear_algebra.qricom(a1,a2,b,4,em,val1,val2,vec1,vec2));
    System.out.println("\nEigenvalues:\n\t" +
      "Real part\tImaginary part");
    for (i=1; i<=4; i++)
      System.out.println("\t" + fiveDigit.format(val1[i]) +
        "\t" + fiveDigit.format(val2[i]));
    Basic.sclcom(vec1,vec2,4,1,4);
    System.out.println("\nFirst eigenvector:\n\t" +
      "Real part\tImaginary part");
    for (i=1; i<=4; i++)
      System.out.println("\t" + fiveDigit.format(vec1[i][1]) +
        "\t" + fiveDigit.format(vec2[i][1]));
    System.out.println("\nEM[3]:  " + 
      fiveDigit.format(em[3]) + "\nEM[5]:  " + (int)em[5]);
	}
}
