package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_qzival extends Object {
	
	public static void main(String args[]) {

    int k;
    int iter[] = new int[5];
    double alfr[] = new double[5];
    double alfi[] = new double[5];
    double beta[] = new double[5];
    double em[] = new double[2];
    double a[][] = new double[5][5];
    double b[][] = new double[5][5];
  
    a[1][1]=2.0;  a[1][2]=3.0;     a[1][3] = -3.0;   a[1][4]=4.0;
    a[2][1]=1.0;  a[2][2] = -1.0;  a[2][3]=5.0;      a[2][4]=1.0;
    a[3][1]=0.0;  a[3][2]=2.0;     a[3][3]=6.0;      a[3][4]=8.0;
    a[4][1]=1.0;  a[4][2]=1.0;     a[4][3]=0.0;      a[4][4]=4.0;
    b[1][1]=1.0;  b[1][2]=5.0;     b[1][3]=9.0;      b[1][4]=0.0;
    b[2][1]=2.0;  b[2][2]=6.0;     b[2][3]=10.0;     b[2][4]=2.0;
    b[3][1]=3.0;  b[3][2]=7.0;     b[3][3]=11.0;     b[3][4] = -1.0;
    b[4][1]=4.0;  b[4][2]=8.0;     b[4][3]=12.0;     b[4][4]=3.0;
    em[0]=1.0e-35;
    em[1]=1.0e-6;
    Linear_algebra.qzival(4,a,b,alfr,alfi,beta,iter,em);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    for (k=1; k<=4; k++)
      System.out.println("ITER[" + k + "] =  " + iter[k]);
    System.out.println("\nALFA(real part)\tALFA(imaginary part)\tBETA");
    for (k=1; k<=4; k++)
      System.out.println(fiveDigit.format(alfr[k]) + "\t" + 
        fiveDigit.format(alfi[k]) + "\t\t" + 
        fiveDigit.format(beta[k]));
    System.out.println("\nLAMBDA(real part)\tLAMBDA(imaginary part)");
    for (k=1; k<=4; k++)
      if (beta[k] == 0.0)
        System.out.println("  INFINITE\t\tINDEFINITE");
      else
        System.out.println(fiveDigit.format(alfr[k]/beta[k]) +
          "\t\t" + fiveDigit.format(alfi[k]/beta[k]));
	}
}
