package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_reaeig3 extends Object {
	
	public static void main(String args[]) {

    int i,j,m;
    double val[] = new double[5]; 
    double em[] = new double[6];
    double a[][] = new double[5][5];
    double vec[][] = new double[5][5];

    for (i=1; i<=4; i++)
      for (j=1; j<=4; j++)
        a[i][j] = (i == 1) ? 1.0 : 1.0/(i+j-1);
    em[0]=1.0e-6;
    em[2]=1.0e-5;
    em[4]=40.0;
    m=Linear_algebra.reaeig3(a,4,em,val,vec);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("The number of not calculated eigenvalues: " +
      m + "\n\nThe eigenvalues and corresponding eigenvectors:\n ");
    for (i=m+1; i<=4; i++)
      System.out.println("\t" + 
        fiveDigit.format(val[i]) + "\t" +
        fiveDigit.format(vec[1][i]) + "\n\t\t\t" +
        fiveDigit.format(vec[2][i]) + "\n\t\t\t" +
        fiveDigit.format(vec[3][i]) + "\n\t\t\t" +
        fiveDigit.format(vec[4][i]) + "\n");
    System.out.println("EM[1] =  " + fiveDigit.format(em[1]) +
      "\nEM[3] =  " + fiveDigit.format(em[3]) +
      "\nEM[5] =  " + (int)em[5]);
	}
}
