package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_valsymtri extends Object {
	
	public static void main(String args[]) {

    double b[] = new double[5];
    double d[] = new double[5];
    double bb[] = new double[4];
    double val[] = new double[3];
    double em[] = new double[10];
    double vec[][] = new double[5][3];

    em[0]=1.0e-6; em[1]=4.0;  em[2]=1.0e-5;
    em[4]=1.0e-3;  em[6]=1.0e-6; em[8]=5.0;
    d[1]=d[2]=d[3]=d[4]=2.0;
    b[4]=0.0; b[1]=b[2]=b[3] = -1.0;
    bb[1]=bb[2]=bb[3]=1.0;
    Linear_algebra.valsymtri(d,bb,4,1,2,val,em);
    Linear_algebra.vecsymtri(d,b,4,1,2,val,vec,em);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("The eigenvalues:\n   " +
      fiveDigit.format(val[1]) + "    " +
      fiveDigit.format(val[2]) +
      "\n\nThe eigenvectors:\n  " +
      fiveDigit.format(vec[1][1]) + "   " +
      fiveDigit.format(vec[1][2]) + "\n   " +
      fiveDigit.format(vec[2][1]) + "  " +
      fiveDigit.format(vec[2][2]) + "\n  " +
      fiveDigit.format(vec[3][1]) + "  " +
      fiveDigit.format(vec[3][2]) + "\n   " +
      fiveDigit.format(vec[4][1]) + "   " +
      fiveDigit.format(vec[4][2]) +     
      "\n\nEM[7] =  " + fiveDigit.format(em[7]) +
      "\nEM[3] =  " + (int)em[3] +
      "\nEM[5] =  " + (int)em[5] +
      "\nEM[9] =  " + (int)em[9]);
	}
}
