package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_ark_2 extends Object
                        implements AP_ark_methods {
 
	public static void main(String args[]) {

    int i;
    double dat2[]={4.0, 3.0, 0.0, 500.0/3.0, 0.0, -1.0, -1.0,
                   0.0, 0.0, 0.0, 1.0, 0.5, 1.0/6.0, 1.0/24.0};
    double data[] = new double[15];
    int m[] = new int[1];
    int m0[] = new int[1];
    double t[] = new double[1];
    double te[] = new double[1];
    double y[] = new double[2];
    double u[] = new double[301];
    
    Test_ark_2 testark = new Test_ark_2();
    for (i=1; i<=14; i++) data[i]=dat2[i-1];
    data[3]=Math.sqrt(8.0);
    data[5]=data[3]/data[4];
    m0[0] = 0;
    m[0]=300;
    t[0]=0.0;
    u[150]=1.0;
    for (i=1; i<=150; i++)
      u[i+150]=u[150-i]=Math.exp(-(0.003*i)*(0.003*i));
    te[0]=0.6;
    Analytic_problems.ark(t,te,m0,m,u,testark,data);
	}


  public void derivative(int m0[], int m[], double t[], double v[])
  {
    int j;
    double v1,v2,v3;

    v2=v[m0[0]];
    m0[0]++;
    m[0]--;
    v3=v[m0[0]];
    for (j=m0[0]; j<=m[0]; j++) {
      v1=v2;
      v2=v3;
      v3=v[j+1];
      v[j]=250.0*(v3-v1)/3.0;
    }
  }


  public void out(int m0[], int m[], double t[], double te[],
                  double u[], double data[])
  {
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    if (Math.abs((t[0])-0.6) < 1.0e-5)
      System.out.println("\n\nProblem 2\n\nderivative " + 
        "calls   u(.6,0)(computed)   u(.6,0)exact\n  " +
        data[1]*data[8] + "            " + 
        fiveDigit.format(u[150]) + "          " +
        fiveDigit.format(Math.exp(-0.09)));
  }
}
