package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_femhermsym extends Object
                             implements AP_femhermsym_methods {

	public static void main(String args[]) {
 
    int n,i,order;
    double rho1,rho2,d1,d2;
    double x[] = new double[11];
    double y[] = new double[19];
    double e[] = new double[5];

    Test_femhermsym testfemhermsym = new Test_femhermsym();
    DecimalFormat twoDigit = new DecimalFormat("0.00E0");
    System.out.println("FEMHERMSYM delivers:\n");
    for (n=5; n<=10; n += 5) {
      e[1]=e[3]=0.0;  e[2]=1.0;  e[4] = -1.0;
      for (i=0; i<=n; i++) x[i]=Math.PI*i/n;
      System.out.println("N=" + n);
      for (order=4; order<=8; order += 2) {
        Analytic_problems.femhermsym(x,y,n,testfemhermsym,order,e);
        rho1=rho2=0.0;
        for (i=1; i<=n-1; i++) {
          d1=Math.abs(y[2*i-1]-Math.sin(x[i]));
          if (rho1 < d1) rho1=d1;
          d2=Math.abs(y[2*i]-Math.cos(x[i]));
          if (rho2 < d2) rho2=d2;
        }
        System.out.println("     ORDER=" + order +
          "\n            MAX. ABS(Y[2*I-1]-Y(X[I])) = " +
          twoDigit.format(rho1) +
          "\n            MAX. ABS(Y[2*I]-Y'(X[I]))  = " +
          twoDigit.format(rho2));
      }
    }
  }


  public double p(double x)
  {
    return 1.0;
  }


  public double q(double x)
  {
    return Math.cos(x);
  }


  public double r(double x)
  {
    return Math.exp(x);
  }


  public double f(double x)
  {
    return Math.sin(x)*(1.0+Math.exp(x)+2.0*Math.cos(x));
  }
}
