package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_femlag extends Object
                         implements AP_femlag_methods {

	public static void main(String args[]) {

    int n,i,order;
    double rho,d;
    double x[] = new double[21];
    double y[] = new double[21];
    double e[] = new double[7];

    Test_femlag testfemlag = new Test_femlag();
    DecimalFormat twoDigit = new DecimalFormat("0.00E0");
    System.out.println("FEMLAG delivers:\n");
    for (n=10; n<=20; n += 10) {
      e[1]=e[4]=1.0;
      e[2]=e[3]=e[5]=e[6]=0.0;
      for (i=0; i<=n; i++) x[i]=Math.PI*i/n;
      System.out.println("N=" + n);
      for (order=2; order<=6; order += 2) {
        Analytic_problems.femlag(x,y,n,testfemlag,order,e);
        rho=0.0;
        for (i=0; i<=n; i++) {
          d=Math.abs(y[i]-Math.sin(x[i]));
          if (rho < d) rho=d;
        }
        System.out.println("     ORDER = " + order +
          "    MAX.ERROR = " + twoDigit.format(rho));
      }
    }
  }


  public double r(double x)
  {
    return Math.exp(x);
  }


  public double f(double x)
  {
    return Math.sin(x)*(1.0+Math.exp(x));
  }
}
