package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_quanewbnd1 extends Object
                             implements AP_quanewbnd_method {
	
	public static void main(String args[]) {

    int i;
    double in[] = new double[6];
    double out[] = new double[6];
    double x[]= new double[601];
    double f[]= new double[601];
    
    Test_quanewbnd1 testquanewbnd1 = new Test_quanewbnd1();
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    for (i=1; i<=600; i++) x[i] = -1.0;
    in[0]=1.0e-6;  in[1]=in[2]=in[3]=1.0e-5;  in[4]=20000.0;
    in[5]=0.001;
    Analytic_problems.quanewbnd1(600,1,1,x,f,testquanewbnd1,in,out);
    System.out.println("Norm Residual vector:  " +
      fiveDigit.format(out[2]) + "\nLength of last step:   " +
      fiveDigit.format(out[1]) +
      "\nNumber of function component evaluations:  " +
      (int)out[3] + "\nNumber of iterations:  " +
      (int)out[4] + "\nReport:  " + (int)out[5]);
	}


  public boolean funct(int n, int l, int u, double x[], double f[])
  {
    int i;
    double x1,x2,x3;

    x1 = (l == 1) ? 0.0 : x[l-1];
    x2=x[l];
    x3 = (l == n) ? 0.0 : x[l+1];
    for (i=l; i<=u; i++) {
      f[i]=(3.0-2.0*x2)*x2+1.0-x1-x3*2.0;
      x1=x2;
      x2=x3;
      x3 = (i <= n-2) ? x[i+2] : 0.0;
    }
    return (true);
  }
}
