package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_zeroinder extends Object
                            implements AP_zeroinder_methods {
	
	public static void main(String args[]) {

    double x[] = new double[1];
    double y[] = new double[1];

    Test_zeroinder testzeroinder = new Test_zeroinder();
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    x[0]=0.0;
    y[0]=1.0;
    if (Analytic_problems.zeroinder(x,y,testzeroinder))
      System.out.println("Calculated zero and function value:" +
        "\n  " + fiveDigit.format(x[0]) + "   " +
        fiveDigit.format(testzeroinder.fx(x)) +
        "\nOther straddling approximation and function value:" +
        "\n  " + fiveDigit.format(y[0]) + "   " +
        fiveDigit.format(testzeroinder.fx(y)));
    else
      System.out.println("No zero found.");
	}

    
  public double fx(double  x[])
  {
    return Math.exp(-x[0]*3.0)*(x[0]-1.0)+x[0]*x[0]*x[0];
  }


  public double tolx(double  x[])
  {
    return Math.abs(x[0])*1.0e-6+1.0e-6;
  }
  
  
  public double dfx(double  x[])
  {
    return Math.exp(-x[0]*3.0)*(-3.0*x[0]+4.0)+3.0*x[0]*x[0];
  }
}
