package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_minmaxpol extends Object {
 
  static double f(double x) {
    return 1.0/(x-10.0);
  }

  static void compute(int n, double a, double b)
  {
  	int k,l,m;
  	double r,idm;
  	double em[] = new double[4];
  	double coef[] = new double[n+1];
  	
  	em[2]=10*n+5;
  	m=100*n+10;
  	double y[] = new double[m+1];
  	double fy[] = new double[m+1];
  	idm=(b-a)/m;
  	r=y[0]=a;
  	fy[0]=f(r);
  	r=y[m]=b;
  	fy[m]=f(r);
  	l=m-1;
  	for (k=1; k<=l; k++) {
  		r=y[k]=a+k*idm;
  		fy[k]=f(r);
  	}
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
  	Approximation.minmaxpol(n,m,y,fy,coef,em);
  	System.out.print(" COEF:   ");
  	for (k=0; k<=n; k++)
      System.out.print("  " + fiveDigit.format(coef[k]));
  	System.out.println("\n EM[0:3]:  " +
      fiveDigit.format(em[0]) + "   " +
      fiveDigit.format(em[1]) + "   " +
      em[2] + "   " + em[3]);
  }

	public static void main(String args[]) {

  	int n;

  	System.out.println("MINMAXPOL delivers:");
  	n=1;
  	System.out.println(" Degree = " + n);
  	compute(n,-1.0,1.0);
  }
}
