package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_comvalqri extends Object {
	
	public static void main(String args[]) {

    int i,j,m,k;
    double re[] = new double[5];
    double im[] = new double[5];
    double u[] = new double[5];
    double v[] = new double[5];
    double em[] = new double[10];
    double a[][] = new double[5][5];
  
    em[0]=1.0e-6;  em[2]=1.0e-6;  em[1]=4.0;  em[4]=40.0;
    em[6]=1.0e-5;  em[8]=5.0;
    for (i=1; i<=4; i++)
      for (j=1; j<=4; j++)
        a[i][j] = (i == 1) ? -1.0 : ((i-j == 1) ? 1.0 : 0.0);
    m=Linear_algebra.comvalqri(a,4,em,re,im);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("The number of not calculated eigenvalues: " +
      m + "\n\nThe eigenvalues and eigenvectors:");
    for (j=m+1; j<=4; j++) {
      for (i=1; i<=4; i++)
        for (k=1; k<=4; k++)
          a[i][k] = (i == 1) ? -1.0 : ((i-k == 1) ? 1.0 : 0.0);
      Linear_algebra.comveches(a,4,re[j],im[j],em,u,v);
      System.out.println("\n  " +
        fiveDigit.format(re[j]) + "    " +
        fiveDigit.format(im[j]) + "\n\n\t" +
        fiveDigit.format(u[1]) + "\t" +
        fiveDigit.format(v[1]) + "\n\t" +
        fiveDigit.format(u[2]) + "\t" +
        fiveDigit.format(v[2]) + "\n\t" +
        fiveDigit.format(u[3]) + "\t" +
        fiveDigit.format(v[3]) + "\n\t" +
        fiveDigit.format(u[4]) + "\t" +
        fiveDigit.format(v[4]));
    }
    System.out.println("\nEM[3] =  " +
      fiveDigit.format(em[3]) +
      "\nEM[7] =  " + fiveDigit.format(em[7]) +
      "\nEM[5] =  " + (int)em[5] +
      "\nEM[9] =  " + (int)em[9]);
	}
}
