package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_decsolsym2 extends Object {
	
	public static void main(String args[]) {

    int i,j;
    int aux[] = new int[6];
    double tol;
    double b[] = new double[6];
    double a[][] = new double[6][6];

    a[1][1]=a[1][2] = -3.0;   a[1][3] = -18.0;
    a[1][4] = -30.0; a[1][5]=18.0;
    a[2][2] = -1.0; a[2][3] = -4.0; a[2][4] = -48.0;  a[2][5]=8.0;
    a[3][3] = -6.0; a[3][4] = -274.0; a[3][5]=6.0;
    a[4][4]=119.0;  a[4][5]=19.0; a[5][5]=216.0;
    b[1]=327.0; b[2]=291.0; b[3]=1290.0; b[4]=275.0;  b[5]=1720.0;
    for (i=1; i<=5; i++)
      for (j=i+1; j<=5; j++) a[j][i]=a[i][j];
    tol=1.0e-6;
    Linear_algebra.decsolsym2(a,5,b,tol,aux);
    if (aux[2] == 1)
      System.out.println("The matrix is symmetric.");
    else
      System.out.println("The matrix is asymmetric," +
                         " results are meaningless.");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("Inertia :  " + (int)(aux[3]) + ",  " + 
                       (int)(aux[4]) + ",  " + (int)(aux[5]));
    System.out.println("The computed solution:\n  " + 
      fiveDigit.format(b[1]) + "  " + fiveDigit.format(b[2]) + "  " +
      fiveDigit.format(b[3]) + "  " + fiveDigit.format(b[4]) + "  " +
      fiveDigit.format(b[5]));
	}
}
