package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_eigcom extends Object {
	
	public static void main(String args[]) {

    int i;
    double em[] = new double[8];
    double valr[] = new double[5];
    double vali[] = new double[5];
    double ar[][] = new double[5][5];
    double ai[][] = new double[5][5];
    double vr[][] = new double[5][5];
    double vi[][] = new double[5][5];

    ar[1][1]=ar[1][4]=ar[2][2]=ar[3][2]=ar[4][1]=ar[4][3]=
    ai[1][2]=ai[1][4]=ai[2][3]=ai[3][3]=ai[4][2]=1.0;
    ar[1][2]=ar[2][3]=ar[3][1]=ai[1][3]=ai[2][2]=ai[3][4]=ai[4][1]=2.0;
    ar[1][3]=ar[2][1]=ar[3][3]=ar[4][2]=
    ai[1][1]=ai[2][4]=ai[3][1]=ai[4][4]=3.0;
    ar[2][4]=ai[2][1]=ai[4][3]=4.0;
    ar[3][4]=ar[4][4]=ai[3][2]=5.0;
    em[0]=5.0e-6;  em[2]=1.0e-5;  em[4]=10.0;  em[6]=10.0;
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("EIGCOM:  " +
      Linear_algebra.eigcom(ar,ai,4,em,valr,vali,vr,vi));
    System.out.println("\nEigenvalues:");
    for (i=1; i<=4; i++)
      System.out.println("\t" + fiveDigit.format(valr[i]) +
        "\t" + fiveDigit.format(vali[i]) + " * I ");
    System.out.println("\nFirst eigenvector:");
    for (i=1; i<=4; i++)
      System.out.println("\t" + fiveDigit.format(vr[i][1]) +
        "\t" + fiveDigit.format(vi[i][1]));
    System.out.println(
      "\nEM[1]:  " + fiveDigit.format(em[1]) +
      "\nEM[3]:  " + fiveDigit.format(em[3]) + 
      "\nEM[5]:  " + (int)em[5] +
      "\nEM[7]:  " + (int)em[7]);
	}
}
