package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_eigsym1 extends Object {
	
	public static void main(String args[]) {

    int i,j;
    double a[] = new double[11];
    double val[] = new double[3];
    double em[] = new double[10];
    double vec[][] = new double[5][3];

    em[0]=1.0e-6; em[2]=1.0e-5; em[4]=1.0e-3;
    em[6]=1.0e-5; em[8]=5.0;
    for (i=1; i<=4; i++)
      for (j=i; j<=4; j++) a[(j*j-j)/2+i]=1.0/(i+j-1);
    Linear_algebra.eigsym1(a,4,2,val,vec,em);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("The eigenvalues:\n   " +
      fiveDigit.format(val[1]) + "    " +
      fiveDigit.format(val[2]) +
      "\n\nThe eigenvectors:\n  " +
      fiveDigit.format(vec[1][1]) + "   " +
      fiveDigit.format(vec[1][2]) + "\n  " +
      fiveDigit.format(vec[2][1]) + "  " +
      fiveDigit.format(vec[2][2]) + "\n  " +
      fiveDigit.format(vec[3][1]) + "  " +
      fiveDigit.format(vec[3][2]) + "\n  " +
      fiveDigit.format(vec[4][1]) + "  " +
      fiveDigit.format(vec[4][2]) +  
      "\n\nEM[1] =  " + fiveDigit.format(em[1]) +   
      "\nEM[7] =  " + fiveDigit.format(em[7]) +
      "\nEM[3] =  " + (int)em[3] +
      "\nEM[5] =  " + (int)em[5] +
      "\nEM[9] =  " + (int)em[9]);
	}
}
