package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_hshhrmtri extends Object {
	
	public static void main(String args[]) {

    double d[] = new double[5];
    double b[] = new double[5];
    double bb[] = new double[5];
    double tr[] = new double[4];
    double ti[] = new double[4];
    double em[] = new double[2];
    double a[][] = new double[5][5];
    
    Basic.inimat(1,4,1,4,a,0.0);
    a[1][1]=a[2][2]=3.0;
    a[1][2]=a[3][3]=a[3][4]=a[4][4]=1.0;
    a[3][2]=2.0;
    a[4][1] = -2.0;
    em[0]=1.0e-6;
    Linear_algebra.hshhrmtri(a,4,d,b,bb,em,tr,ti);
    DecimalFormat threeeDigit = new DecimalFormat("0.000");
    System.out.println("HSHHRMTRI delivers\n\nD[1:4]:   " +
      threeeDigit.format(d[1]) + "  " +
      threeeDigit.format(d[2]) + "  " +
      threeeDigit.format(d[3]) + "  " +
      threeeDigit.format(d[4]) + "\nB[1:3]:   " +
      threeeDigit.format(b[1]) + "  " +
      threeeDigit.format(b[2]) + "  " +
      threeeDigit.format(b[3]) + "\nBB[1:3]:  " +
      threeeDigit.format(bb[1]) + "  " +
      threeeDigit.format(bb[2]) + "  " +
      threeeDigit.format(bb[3]) + "\nEM[1]:    " +
      threeeDigit.format(em[1]));
  }
}
