package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_lsqortdec extends Object {
	
	public static void main(String args[]) {

    int i;
    int piv[] = new int[3];
    double sum,temp;
    double b[] = new double[6];
    double x[] = new double[6];
    double diag[] = new double[3];
    double aid[] = new double[3];
    double aux[] = new double[6];
    double a[][] = new double[6][3];
    double c[][] = new double[6][3];

    aux[2]=1.0e-6;
    a[1][1]=c[1][1] = -2.0;
    a[2][1]=c[2][1] = -1.0;
    a[3][1]=c[3][1]=1.0;
    a[4][1]=c[4][1]=2.0;
    a[5][1]=c[5][1]=1.0;
    a[1][2]=a[2][2]=a[3][2]=a[4][2]=c[1][2]=c[2][2]=c[3][2]=c[4][2]=1.0;
    a[5][2]=c[5][2]=2.0;
    b[1]=x[1]=0.0;
    b[2]=x[2]=1.0;
    b[3]=x[3]=b[4]=x[4]=2.0;
    b[5]=x[5]=3.0;
    Linear_algebra.lsqortdec(a,5,2,aux,aid,piv);
    if (aux[3] == 2) {
      Linear_algebra.lsqsol(a,5,2,aid,piv,x);
      Linear_algebra.lsqdglinv(a,2,aid,piv,diag);
      sum=0.0;
      for (i=1; i<=5; i++) {
        temp=b[i]-c[i][1]*x[1]-c[i][2]*x[2];
        sum += temp*temp;
      }
      DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
      System.out.println("Aux[2, 3, 5] =  " + 
        fiveDigit.format(aux[2]) +
        "  " + fiveDigit.format(aux[3]) + "  " +
        fiveDigit.format(aux[5]) +
        "\nLSQ solution :  " + fiveDigit.format(x[1]) + "  " +
        fiveDigit.format(x[2]) + "\nResidue (delivered) :  " +
        fiveDigit.format(Math.sqrt(Basic.vecvec(3,5,0,x,x))) +
        "\nResidue (checked)   :  " +
        fiveDigit.format(Math.sqrt(sum)) +
        "\nDiagonal of inverse M'M :  " + fiveDigit.format(diag[1]) +
        "  " + fiveDigit.format(diag[2]));
    }
	}
}
