package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_qrihrm extends Object {
	
	public static void main(String args[]) {

    int i;
    double val[] = new double[5]; 
    double em[] = new double[6];
    double a[][] = new double[5][5];
    double vr[][] = new double[5][5];
    double vi[][] = new double[5][5];
    
    Basic.inimat(1,4,1,4,a,0.0);
    a[1][1]=a[2][2]=3.0;
    a[3][2]=2.0;  a[4][1] = -2.0;
    a[1][2]=a[3][3]=a[3][4]=a[4][4]=1.0;
    em[0]=em[2]=5.0e-5;
    em[4]=20.0;
    DecimalFormat twoDigit = new DecimalFormat("##");
    DecimalFormat threeDigit = new DecimalFormat("0.000");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    
    System.out.println("QRIHRM: " + 
      Linear_algebra.qrihrm(a,4,val,vr,vi,em));
    Basic.sclcom(vr,vi,4,2,3);
    System.out.println("\nEigenvalues:" +
      "\n  VAL[1]:   " + threeDigit.format(val[1]) +
      "\n  VAL[2]:   " + threeDigit.format(val[2]) +
      "\n  VAL[3]:  " + threeDigit.format(val[3]) + 
      "\n  VAL[4]:  " + threeDigit.format(val[4]) +        
      "\n\nEigenvectors corresponding to\n   VAL[2]      VAL[3]");
    for (i=1; i<=4; i++)
      System.out.println("   " +
      twoDigit.format(vr[i][2]) + "  " +
      twoDigit.format(vi[i][2]) + "*I" + "      " + 
      twoDigit.format(vr[i][3]) + "  " +
      twoDigit.format(vi[i][3]) + "*I");
    System.out.println("\nEM[1]:  " + fiveDigit.format(em[1]) +
      "\nEM[3]:  " + fiveDigit.format(em[3]) +
      "\nEM[5]:  " + fiveDigit.format(em[5]));
	}
}
