package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_qrisngvaldec extends Object {
	
	public static void main(String args[]) {

    int i,j;
    double val[] = new double[6];
    double em[] = new double[8];
    double a[][] = new double[7][6];
    double v[][] = new double[6][6];

    for (i=1; i<=6; i++)
      for (j=1; j<=5; j++) a[i][j]=1.0/(i+j-1);
    em[0]=1.0e-6;  em[2]=1.0e-5;  em[4]=25.0;  em[6]=1.0e-5;
    i=Linear_algebra.qrisngvaldec(a,6,5,val,v,em);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("Number of singular values not found :  " +
      i + "\n\nInfinity norm :  " + fiveDigit.format(em[1]) +
      "\nMax neglected subdiagonal element :  " + 
      fiveDigit.format(em[3]) +
      "\nNumber of iterations :  " + (int)em[5] +
      "\nNumerical rank :  " + (int)em[7] +
      "\n\nSingular values :");
    for (i=1; i<=5; i++)
      System.out.println("  " + fiveDigit.format(val[i]));
    System.out.println("\nMatrix U, first 3 columns :");
    for (i=1; i<=6; i++)
      System.out.println("  " +
        fiveDigit.format(a[i][1]) + "\t" +
        fiveDigit.format(a[i][2]) + "\t" +
        fiveDigit.format(a[i][3]));
    System.out.println("Last 2 columns :");
    for (i=1; i<=6; i++)
      System.out.println("  " +
        fiveDigit.format(a[i][4]) + "\t" +
        fiveDigit.format(a[i][5]));
	}
}
