package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_symeigimp extends Object {
	
	public static void main(String args[]) {

    int i,j;
    double val[] = new double[5];
    double lbound[] = new double[5];
    double ubound[] = new double[5];
    double em[] = new double[6];
    double aux[] = new double[6];
    double a[][] = new double[5][5];
    double x[][] = new double[5][5];

    a[1][1]=a[2][2]=a[3][3]=a[4][4]=6.0;
    a[1][2]=a[2][1]=a[3][1]=a[1][3]=4.0;
    a[4][2]=a[2][4]=a[3][4]=a[4][3]=4.0;
    a[1][4]=a[4][1]=a[3][2]=a[2][3]=1.0;
    for (i=1; i<=4; i++)
      for (j=i; j<=4; j++) x[i][j]=x[j][i]=a[i][j];
    em[0]=1.0e-6; em[4]=100.0;  em[2]=1.0e-5;
    Linear_algebra.qrisym(x,4,val,em);
    aux[0]=0.0;   aux[4]=10.0;  aux[2]=1.0e-6;
    Linear_algebra.symeigimp(4,a,x,val,lbound,ubound,aux);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("\nThe exact eigenvalues are:  -1,  5,  5,  15\n\n" +
      "The computed eigenvalues:\n  " +
      fiveDigit.format(val[1]) + "\n   " +
      fiveDigit.format(val[2]) + "\n   " +
      fiveDigit.format(val[3]) + "\n   " +
      fiveDigit.format(val[4]) +
      "\n\n Lowerbounds   Upperbounds\n " +
      fiveDigit.format(lbound[1]) + "   " +
      fiveDigit.format(ubound[1]) + "\n " +
      fiveDigit.format(lbound[2]) + "   " +
      fiveDigit.format(ubound[2]) + "\n " +
      fiveDigit.format(lbound[3]) + "   " +
      fiveDigit.format(ubound[3]) + "\n " +
      fiveDigit.format(lbound[4]) + "   " +
      fiveDigit.format(ubound[4]) + 
      "\n\nNumber of iterations = " + (int)aux[5] +
      "\nInfinity norm of A   = " + (int)aux[1] + 
      "\nMaximum absolute element of residu = " + 
      fiveDigit.format(aux[3]));
	}
}
