package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_zerpol extends Object {
	
	public static void main(String args[]) {

    int i,j;
    double a[] = new double[8];
    double d[] = new double[8];
    double re[] = new double[8];
    double im[] = new double[8];
    double em[] = new double[5];
    double recentre[] = new double[8];
    double imcentre[] = new double[8];
    double bound[] = new double[8];

    a[7]=1.0;   a[6]=a[5] = -3.0;  a[4]=25.0;  a[3] = -46.0;
    a[2]=38.0;  a[1] = -12.0;      a[0]=0.0;
    em[0]=1.0e-6;  em[1]=40.0;
    i=Linear_algebra.zerpol(7,a,em,re,im,d);
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.print("Coefficients of polynomial:\n  ");
    for (j=7; j>=0; j--) System.out.print("  " + a[j]);
    System.out.println("\n\nNumber of not found zeros:  " + i +
      "\nFail indication:            " + (int)em[2] +
      "\nNumber of new starts:       " + (int)em[3] +
      "\nNumber of iterations:       " + (int)em[4] + "\n\nZeros:");
    for (j=i+1; j<=7; j++)
      if (im[j] == 0.0)
        System.out.println("  " + fiveDigit.format(re[j]));
      else
        System.out.println("  " + fiveDigit.format(re[j]) +
          "\t" + fiveDigit.format(im[j]));
    if (i == 0) {
      Linear_algebra.bounds(7,a,re,im,0.0,0.0,recentre,imcentre,bound);
      System.out.println("\nReal and imaginary part of centre + radius");
      for (j=1; j<=7; j++)
        System.out.println("  " +
          fiveDigit.format(recentre[j]) + "\t" +
          fiveDigit.format(imcentre[j]) + "\t" +
          fiveDigit.format(bound[j]));
    }
	}
}
