package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_jacobnbndf extends Object
                             implements AE_jacobnbndf_methods {
	
	public static void main(String args[]) {

    int i;
    double x[] = new double[6];
    double f[] = new double[6];
    double jac[] = new double[14];
    
    Test_jacobnbndf testjacobnbndf = new Test_jacobnbndf();
    for (i=1; i<=5; i++) x[i] = -1.0;
    testjacobnbndf.funct(5,1,5,x,f);
    Analytic_eval.jacobnbndf(5,1,1,x,f,jac,testjacobnbndf);
    DecimalFormat oneDigit = new DecimalFormat("0.0E0");
    System.out.println("The calculated tridiagonal jacobian is:\n" +
      oneDigit.format(jac[1]) + "\t" +
      oneDigit.format(jac[2]) + "\n" +
      oneDigit.format(jac[3]) + "\t" +
      oneDigit.format(jac[4]) + "\t" +
      oneDigit.format(jac[5]) + "\n\t" +
      oneDigit.format(jac[6]) + "\t" +
      oneDigit.format(jac[7]) + "\t" +
      oneDigit.format(jac[8]) + "\n\t\t" +
      oneDigit.format(jac[9]) + "\t" +
      oneDigit.format(jac[10]) + "\t" +
      oneDigit.format(jac[11]) + "\n\t\t\t" +
      oneDigit.format(jac[12]) + "\t" +
      oneDigit.format(jac[13]));
  }


  public double di(int i, int m) {
    return ((i == 5) ? 1.0 : 1.0e-6);
  }
  

  public void funct(int n, int l, int u, double x[], double f[]) {
    int i;

    for (i=l; i<=((u == 5) ? 4 : u); i++) {
      f[i]=(3.0-2.0*x[i])*x[i]+1.0-2.0*x[i+1];
      if (i != 1) f[i] -= x[i-1];
    }
    if (u == 5) f[5]=4.0-x[4]-x[5]*2.0;
  }

}
