package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_ark_1 extends Object
                        implements AP_ark_methods {
 
	public static void main(String args[]) {

    int i;
    double dat1[]={3.0, 3.0, 1.0, 1.0, 1.0e-3, 1.0e-6,
                     1.0e-6, 0.0, 0.0, 0.0, 1.0, 0.5, 1.0/6.0};
    double data[] = new double[15];
    int m[] = new int[1];
    int m0[] = new int[1];
    double t[] = new double[1];
    double te[] = new double[1];
    double y[] = new double[2];

    Test_ark_1 testark = new Test_ark_1();
    for (i=1; i<=13; i++) data[i]=dat1[i-1];
    t[0]=0.0;
    y[1]=1.0;
    te[0]=1.0;
    m0[0]=m[0]=1;
    Analytic_problems.ark(t,te,m0,m,y,testark,data);
	}


  public void derivative(int m0[], int m[], double t[], double v[])
  {
    v[1] -= 2.0*(t[0])/v[1];
  }


  public void out(int m0[], int m[], double t[], double te[],
                  double y[], double data[])
  {
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    if (t[0] == te[0]) {
      if (t[0] == 1.0)
        System.out.println("\nProblem 1\n\n" +
          " x   integration steps   y(computed)    y(exact)");
      System.out.println(" " + (int)t[0] + "           " +
        (int)data[8] + "          " + fiveDigit.format(y[1]) +
        "      " + fiveDigit.format(Math.sqrt(2.0*(t[0])+1)));
      te[0] = 2.0;
    }
  }
}
