package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_femlagspher extends Object
                              implements AP_femlagspher_methods {

  static int nc;
  
	public static void main(String args[]) {

    int n,i,order;
    double rho,d;
    double x[] = new double[21];
    double y[] = new double[21];
    double e[] = new double[7];
    
    Test_femlagspher testfemlagspher = new Test_femlagspher();
    DecimalFormat twoDigit = new DecimalFormat("0.00E0");
    System.out.println("FEMLAGSPHER delivers:\n");
    for (n=10; n<=20; n += 10)
      for (nc=0; nc<=2; nc++) {
        e[2]=e[4]=1.0;
        e[1]=e[3]=e[5]=e[6]=0.0;
        for (i=0; i<=n; i++) x[i]=(float)(i)/(float)(n);
        System.out.println("N= " + n + "    NC=" + nc);
        for (order=2; order<=4; order += 2) {
          Analytic_problems.femlagspher(x,y,n,nc,testfemlagspher,
                                        order,e);
          rho=0.0;
          for (i=0; i<=n; i++) {
            d=Math.abs(y[i]-1.0+x[i]*x[i]*x[i]*x[i]);
            if (rho < d) rho=d;
          }
          System.out.println("         ORDER = " + order +
          "    MAX.ERROR = " + twoDigit.format(rho));
        }
      }
  }


  public double r(double x)
  {
  return 1.0;
  }


  public double f(double x)
  {
    return (12+4*nc)*x*x+1.0-x*x*x*x;
  }
}
