package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_praxis extends Object
                         implements AP_praxis_method {
	
	public static void main(String args[]) {

    double x[] = new double[3];
    double in[] = new double[10];
    double out[] = new double[7];

    Test_praxis testpraxis = new Test_praxis();
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    in[0]=1.0e-6;  in[1]=in[2]=1.0e-6;  in[5]=250.0;
    in[6]=in[7]=in[8]=in[9]=1.0;
    x[1] = -1.2;  x[2]=1.0;
    Analytic_problems.praxis(2,x,testpraxis,in,out);
    if (out[1] == 0.0)
      System.out.println("Normal Termination\n");
    System.out.println("Minimum is  " +
      fiveDigit.format(out[2]) + "\nFor x is  " +
      fiveDigit.format(x[1]) + "    " + 
      fiveDigit.format(x[2]) +
      "\nThe initial function value was  " +
      fiveDigit.format(out[3]) +
      "\nThe number of function evaluations needed was  " +
      (int)out[4] + "\nThe number of line searches was  " +
      (int)out[5] + "\nThe step size in the last " +
      "iteration step was  " + fiveDigit.format(out[6]));
	}


  public double funct(int n, double x[])
  {
    double temp;

    temp=x[2]-x[1]*x[1];
    return temp*temp*100.0+(1.0-x[1])*(1.0-x[1]);
  }
}
