package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_rk2 extends Object implements AP_rk2_method {

	public static void main(String args[]) {
 
    boolean fi;
    int i;
    double x[] = new double[1];
    double y[] = new double[1];
    double z[] = new double[1];
    double e[] = new double[5];
    double d[] = new double[6];
    double b[] = {9.32386578, 18.86305405, 28.40224162, 37.94142918};

    Test_rk2 testrk2 = new Test_rk2();
    DecimalFormat fourDigit = new DecimalFormat("0.0000E0");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000");
    e[1]=e[2]=e[3]=e[4]=1.0e-8;
    System.out.println("RK2 delivers :\n");
    for (i=0; i<=3; i++) {
      fi=(b[i] < 10.0);
      Analytic_problems.rk2(x,0.0,b[i],y,2.0,z,0.0,testrk2,e,d,fi);
      System.out.println("  X = " + 
        fiveDigit.format(x[0]) + "\tY = " +
        fiveDigit.format(y[0]) + "\tDY/DX = " +
        fourDigit.format(z[0]));
    }
	}


  public double fxyz(double x[], double y[], double z[])
  {
    return 10.0*(1.0-y[0]*y[0])*z[0]-y[0];
  }
}
