package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_rk2n extends Object implements AP_rk2n_method {

	public static void main(String args[]) {

    boolean fi;
    int k;
    double b,expx;
    double y[] = new double[3];
    double ya[] = new double[3];
    double z[] = new double[3];
    double za[] = new double[3];
    double e[] = new double[9];
    double d[] = new double[8];
    double x[] = new double[1];

    Test_rk2n testrk2n = new Test_rk2n();
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    System.out.println("Results from RK2N :");
    for (k=1; k<=8; k++) e[k]=1.0e-5;
    ya[1]=za[2]=1.0;
    ya[2]=za[1]=0.0;
    b=1.0;
    do {
      fi=(b == 1.0);
      Analytic_problems.rk2n(x,0.0,b,y,ya,z,za,testrk2n,e,d,fi,2);
      expx=Math.exp(-x[0]);
      ya[1] = -expx*(expx*(expx*(expx/3.0+0.5)-1.0)-5.0/6.0);
      ya[2] = -expx*(expx*(expx*(expx/3.0-0.5)+1.0)-5.0/6.0);
      za[1]=expx*(expx*(expx*(expx/0.75+1.5)-2.0)-5.0/6.0);
      za[2]=expx*(expx*(expx*(expx/0.75-1.5)+2.0)-5.0/6.0);
      System.out.println("\n  X = " + fiveDigit.format(x[0]) +
        "\nY[1]-YEXACT[1] = " + fiveDigit.format(y[1]-ya[1]) +
        "    Y[2]-YEXACT[2] = " + fiveDigit.format(y[2]-ya[2]) +
        "\nZ[1]-ZEXACT[1] = " + fiveDigit.format(z[1]-za[1]) +
        "    Z[2]-ZEXACT[2] = " + fiveDigit.format(z[2]-za[2]));
      b += 1.0;
    } while (b < 5.0);
	}


  public double fxyzj(int n, int j, double x[],
                      double y[], double z[])
  {
    return -5.0*(y[j]+z[j])+((j == 1) ? y[2] : y[1]);
  }
}
