package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_rk3 extends Object implements AP_rk3_method {

	public static void main(String args[]) {

    boolean fi;
    int n,i;
    double x3,s,term;
    double b[]={0.25, 0.50, 0.75, 1.00};
    double e[] = new double[6];
    double d[] = new double[6];
    double x[] = new double[1];
    double y[] = new double[1];
    double z[] = new double[1];

    Test_rk3 testrk3 = new Test_rk3();
    DecimalFormat twoDigit = new DecimalFormat("0.00E0");
    DecimalFormat fiveDigit = new DecimalFormat("0.00000");
    e[1]=e[3]=1.0e-6;
    e[2]=e[4]=1.0e-6;
    System.out.println("RK3 delivers :\n");
    for (i=0; i<=3; i++) {
      fi=(b[i] < 0.3);
      Analytic_problems.rk3(x,0.0,b[i],y,0.0,z,1.0,testrk3,e,d,fi);
      x3=x[0]*x[0]*x[0];
      term=x[0];
      s=0.0;
      n=3;
      do {
        s += term;
        term=term*x3/n/(n+1);
        n += 3;
      } while (Math.abs(term) > 1.0e-14);
      System.out.println("Y-YEXACT= " +
        twoDigit.format(y[0]-s) + "\tX= " +
        x[0] + "\t\tY= " + fiveDigit.format(y[0]));
    }
	}


  public double fxy(double x[], double y[])
  {
    return x[0]*y[0];
  }
}
