package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_rk3n extends Object implements AP_rk3n_method {

	public static void main(String args[]) {

    boolean fi;
    int k,i,n,j;
    double b,x2,term;
    double y[] = new double[3];
    double ya[] = new double[3];
    double z[] = new double[3];
    double e[] = new double[9];
    double d[] = new double[8];  
    double x[] = new double[1];
    
    Test_rk3n testrk3n = new Test_rk3n();
    DecimalFormat twoDigit = new DecimalFormat("0.00E0");
    System.out.println("Results from RK3N :\n");
    for (k=1; k<=8; k++) e[k]=1.0e-5;
    fi=true;
    y[1]=y[2]=1.0;
    z[1]=z[2]=0.0;
    b=0.0;
    do {
      b += 1.0;
      Analytic_problems.rk3n(x,0.0,b,y,y,z,z,testrk3n,e,d,fi,2);
      ya[1]=ya[2]=0.0;
      term=1.0;
      x2=x[0]*x[0]*0.5;
      n=1;
      do {
        for (i=1; i<=2; i++) {
          j=(i+n-2)/2;
          ya[i] += term*((j%2 == 0) ? 1 : -1);
        }
        term=term*x2/n/(n*2-1);
        n++;
      } while (Math.abs(term) > 1.0e-14);
      System.out.println(" ABS(YEXACT[1]-Y[1])+" + 
        "ABS(YEXACT[2]-Y[2]) = " +
        twoDigit.format(Math.abs(y[1]-ya[1])+
                        Math.abs(ya[2]-y[2])));
      fi=false;
    } while (b < 5.0);
	}


  public double fxyj(int n, int j, double x[], double y[])
  {
    return ((j == 1) ? y[2] : -y[1]);
  }
}
