package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_rk4na extends Object
                                implements AP_rk4na_methods {
	
	public static void main(String args[]) {

    boolean first;
    int j;
    double x0;
    double e[] = new double[8];
    double xa[] = new double[3];
    double x[] = new double[3];
    double d[] = new double[6];

    DecimalFormat eightDigit = new DecimalFormat("0.00000000");
    Test_rk4na testrk4na = new Test_rk4na();
    for (j=0; j<=5; j++) e[j]=0.1e-6;
    e[6]=e[7]=1.0e-8;
    System.out.println("VAN DER POL\n\nEPS = " +
      eightDigit.format(e[0]) +
      "\n\nThe values of x[0],x[1],x[2],p:");
    x0=xa[0]=xa[2]=0.0;
    xa[1]=2.0;
    System.out.println("  " + eightDigit.format(xa[0]) +
      "\t" + eightDigit.format(xa[1]) + "\t" +
      eightDigit.format(xa[2]) + "\t" + eightDigit.format(x0));
    first=true;
    for (j=1; j<=4; j++) {
      Analytic_problems.rk4na(x,xa,testrk4na,e,d,first,2,0,true);
      x0=x[0]-x0;
      System.out.println("  " + eightDigit.format(x[0]) +
        "\t" + eightDigit.format(x[1]) + "\t" +
        eightDigit.format(x[2]) + "\t" + eightDigit.format(x0));
      first=false;
      x0=x[0];
    }
	}


  public double b(int n, double x[])
  {
    return x[2];
  }


  public double fxj(int n, int k, double x[])
  {
    return ((k == 1) ? x[2] : 10.0*(1.0-x[1]*x[1])*x[2]-x[1]);
  }
}
