package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_rk5na extends Object
                                implements AP_rk5na_methods {
	
	public static void main(String args[]) {

    boolean first;
    int j;
    double e[] = new double[6];
    double xa[] = new double[2];
    double x[] = new double[2];
    double d[] = new double[5];

    DecimalFormat eightDigit = new DecimalFormat("0.00000000");
    Test_rk5na testrk5na = new Test_rk5na();
    for (j=0; j<=3; j++) e[j]=1.0e-6;
    e[4]=e[5]=1.0e-10;
    d[1]=0.0;
    xa[0]=2.0;  xa[1]=0.0;
    j=0;
    System.out.println("Results:\n    " +
      "x[0]           x[1]            s\n" +
      "  " + eightDigit.format(xa[0]) + "\t" +
      eightDigit.format(xa[1]) + "\t" + 
      eightDigit.format(Math.abs(d[1])));
    do {
      first=(j == 0);
      Analytic_problems.rk5na(x,xa,testrk5na,e,d,first,1,1,false);
      j++;
      System.out.println(
        "  " + eightDigit.format(x[0]) + "\t" +
        eightDigit.format(x[1]) + "\t" + 
        eightDigit.format(Math.abs(d[1])));
    } while (j < 4);
	}


  public double b(int n, double x[])
  {
    return x[1];
  }


  public double fxj(int n, int k, double x[])
  {
    return ((k == 0) ? x[1] : 10.0*(1.0-x[0]*x[0])*x[1]-x[0]); 
  }
}
