package numal;

import java.text.DecimalFormat;
import numal.*;

public class Test_rnk1min extends Object
                          implements AP_linemin_method {
	
	public static void main(String args[]) {

    boolean again;
    double f;
    double x[] = new double[3];
    double g[] = new double[3];
    double h[] = new double[4];
    double in[] = new double[9];
    double out[] = new double[5];

    Test_rnk1min testrnk1min = new Test_rnk1min();
    DecimalFormat fiveDigit = new DecimalFormat("0.00000E0");
    in[0]=1.0e-6;  in[1]=in[2]=1.0e-5;  in[3]=1.0e-4;
    in[4]=1.0e-5;  in[5] = -10.0;  in[6]=1.0;  in[7]=100.0;
    in[8]=0.01;
    x[1] = -1.2;  x[2]=1.0;
    again=true;
    f=Analytic_problems.rnk1min(2,x,g,h,testrnk1min,in,out);
    while (true) {
      System.out.println("\nLeast value:  " +
        fiveDigit.format(f) + "\nx:          " +
        fiveDigit.format(x[1]) + "    " +
        fiveDigit.format(x[2]) + "\nGradient:  " +
        fiveDigit.format(g[1]) + "   " +
        fiveDigit.format(g[2]) + "\nMetric:     " +
        fiveDigit.format(h[1]) + "   " +
        fiveDigit.format(h[2]) + "\n            " +
        "             " + fiveDigit.format(h[3]) +     
        "\nOUT:  " + fiveDigit.format(out[0]) +
        "\n      " + fiveDigit.format(out[1]) +
        "\n      " + (int)out[2] +
        "\n      " + (int)out[3] +
        "\n      " + (int)out[4]);
      if (again) {
        x[1] = -1.2;  x[2]=1.0;
        again=false;
        f=Analytic_problems.flemin(2,x,g,h,testrnk1min,in,out);
      } else
        break;
    }
	}


  public double funct(int n, double x[], double g[])
  {
    double temp;

    temp=x[2]-x[1]*x[1];
    g[1]=(-temp*400.0+2.0)*x[1]-2.0;
    g[2]=temp*200.0;
    return temp*temp*100.0+(1.0-x[1])*(1.0-x[1]);
  }
}
